/* SPDX-License-Identifier: GPL-2.0 */
/*
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Macros for 32/64-bit neutral inline assembler
 * Copyright (C) 2020 Loongson Technology Corporation Limited
 */

#ifndef __ASM_LLSC_H
#define __ASM_LLSC_H

#if _LOONGARCH_SZLONG == 32
#define SZLONG_LOG 5
#define SZLONG_MASK 31UL
#define __LL		"ll.w	"
#define __SC		"sc.w	"
#define __INS		"ins	"
#define __EXT		"ext	"
#define __AMADD		"amadd.w	"
#define __AMAND_SYNC	"amand_db.w	"
#define __AMOR_SYNC	"amor_db.w	"
#define __AMXOR_SYNC	"amxor_db.w	"
#elif _LOONGARCH_SZLONG == 64
#define SZLONG_LOG 6
#define SZLONG_MASK 63UL
#define __LL		"ll.d	"
#define __SC		"sc.d	"
#define __INS		"dins	"
#define __EXT		"dext	"
#define __AMADD		"amadd.d	"
#define __AMAND_SYNC	"amand_db.d	"
#define __AMOR_SYNC	"amor_db.d	"
#define __AMXOR_SYNC	"amxor_db.d	"
#endif

#endif /* __ASM_LLSC_H  */
